﻿/*
La funcion boton asigna los eventos de rollover y rollout automaticamente
y tiene los metodos para habilitaro deshabilitar al boton. Ademas tenemos la opcion de darle al boton un estado de seleccioando
*/
class Boton extends MovieClip {
	// Primero definimos las variables que usaremos dentro de la clase
	public function click() {
	}
	// generamos una funcion click que sera un metodo donde asignaremos la accion del boton
	var press:Boolean;
	// variable booleana que define si el boton tiene o no un estado seleccionado
	var pos:Number;
	// variable donde guardaremos la posicion dentro de la lista que tiene el boton
	/*
	funcion constructora de la clase. En esta funcion asignamos los eventos del boton
	*/
	public function Boton() {
		//en onPress asignamos la funcion click que dira que hacer y en en caso de tener estado seleccionado vamos al mismo y deshabilitamos el boton
		this.onPress = function() {
			this.click();
			if (this.press == true) {
				this.presionado(true);
				_global.seleccionado.presionado(false);
				_global.seleccionado = this;
			}
		};
		// en onRollOver dirigimos el cabezal del boton al frame llamado "over" para generar el efecto
		this.onRollOver = function() {
			this.gotoAndPlay("over");
		};
		// en onRollOut dirigimos el cabezal del boton al frame llamado "out" para generar el efecto
		this.onRollOut = this.onReleaseOutside=function () {
			this.gotoAndPlay("out");
		};
	}
	/*
	METODOS:
	esta es una function privada que lleva a cabo el efecto del boton al ser seleccionado y al dejar de estarlo
	*/
	private function presionado(estado:Boolean):Void {
		if (estado == true) {
			this.gotoAndPlay("press");
			this.enabled = false;
		} else {
			this.enabled = true;
			this.gotoAndPlay("pressout");
		}
	}
	/*
	SETTERS Y GETTERS:
	habilitado es un metodo set y get que habilita y deshabilita segun su valor booleano al boton, con un efecto de alpha sobre el boton
	*/
	public function set _habilitado(estado:Boolean):Void {
		if (estado == false) {
			this.gotoAndPlay("out");
			this.onEnterFrame = function() {
				if (this._alpha>50) {
					this._alpha -= 5;
				} else {
					this.onEnterFrame = null;
					this.enabled = estado;
				}
			};
		} else if (estado == true) {
			this.onEnterFrame = function() {
				if (this._alpha<100) {
					this._alpha += 5;
				} else {
					this.onEnterFrame = null;
					this.enabled = estado;
				}
			};
		}
	}
	public function get _habilitado():Boolean {
		return this.enabled;
	}
	// metodos set y get de _press que asigana si el boton tiene estado de seleccionado o no
	public function set _press(estado:Boolean) {
		this.press = estado;
	}
	public function get _press():Boolean {
		return this.press;
	}
	// metodos set y get de _pos que nos guarda y asigna la posicion en la lista del boton
	public function set _pos(valor:Number) {
		this.pos = valor;
	}
	public function get _pos():Number {
		return this.pos;
	}
}
// fin clase Boton 
